/* ------------------------------------------------------------------------
   Démonstration "Cross-compilation / Remote-debug sur BeagleBone Black"
   
   Conférence "Solutions Linux pour systèmes embarqués"
   Christophe BLAESS 2015
   ------------------------------------------------------------------------ */

#define _XOPEN_SOURCE 500

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define FLASH_NUMBER   4
#define SMALL_DELAY    200000  // 200 ms
#define LONG_DELAY     400000  // 400 ms
#define NUMBER_OF_LEDS 4 

int main(void)
{
	int i;
	int flash;
	int fd[NUMBER_OF_LEDS];
	char filename[128];

	// Open the LEDS devices.
	for (i = 0; i < NUMBER_OF_LEDS; i ++) {
		sprintf(filename, "/sys/class/leds/beaglebone:green:usr%d/brightness", i);
		fd[i] = open(filename, O_WRONLY);
		if (fd[i]  < 0) {
			perror(filename);
			exit(EXIT_FAILURE);
		}
	}

	for(;;) {
		for (flash = 0; flash < FLASH_NUMBER; flash ++) {
			for (i = 0; i < NUMBER_OF_LEDS; i ++)
				pwrite(fd[i], "1\n", 2, 0);
			usleep(SMALL_DELAY);
			for (i = 0; i < NUMBER_OF_LEDS; i ++)
				pwrite(fd[i], "0\n", 2, 0);
			usleep(SMALL_DELAY);
		}
		usleep(LONG_DELAY);
	}
	return 0;
}

